/* dnntp.h */
/* global include for dnntpd*/
/* Thu Jan 28 14:54:12 EST 1993 wbardwel : created*/
/*
 * HISTORY
 * $Log:	dnntp.h,v $
 * Revision 2.39  95/02/21  16:40:00  wbardwel
 * 	add field for IDLE_CLOSE stuff from noyd@u.washington.edu
 * 	[95/02/21  16:32:41  wbardwel]
 * 
 * Revision 2.38  95/02/08  13:08:35  wbardwel
 * 	fix typo
 * 	[95/02/08  13:02:45  wbardwel]
 * 
 * Revision 2.37  95/01/09  00:45:24  wbardwel
 * 	change Prep to match RealG2SPrep
 * 	[95/01/09  00:41:16  wbardwel]
 * 
 * Revision 2.36  95/01/05  14:11:30  wbardwel
 * 	fix decl for group_array_secs
 * 	[95/01/05  14:09:44  wbardwel]
 * 
 * Revision 2.35  95/01/05  13:57:13  wbardwel
 * 	add G2SI
 * 	[95/01/05  13:26:10  wbardwel]
 * 
 * Revision 2.34  95/01/01  23:20:35  wbardwel
 * 	make G2SLCFresh return time_t
 * 	[95/01/01  23:16:50  wbardwel]
 * 
 * Revision 2.33  94/12/15  00:44:35  wbardwel
 * 	added list3_cmd for "LIST ACTIVE <grouppat>" support
 * 	[94/12/15  00:31:43  wbardwel]
 * 
 * Revision 2.32  94/07/30  01:47:20  wbardwel
 * 	cleanup based on linux/gcc whines
 * 	[94/07/30  01:42:03  wbardwel]
 * 
 * Revision 2.31  94/07/27  22:15:04  wbardwel
 * 	fix SysV (USG) stuff to not fight with HPUX BSD compat stuff
 * 	[94/07/27  22:09:18  wbardwel]
 * 
 * Revision 2.30  94/07/12  17:26:35  wbardwel
 * 	update copyright, fix for svr4
 * 	[94/07/12  17:21:52  wbardwel]
 * 
 * Revision 2.29  94/05/17  04:36:43  wbardwel
 * 	update DO_POST_NEWSGROUP_HDR to match new do_post (include : in check)
 * 	[94/05/17  04:33:29  wbardwel]
 * 
 * Revision 2.28  94/02/16  17:20:44  wbardwel
 * 	kill salloc stuff
 * 	[94/02/16  17:19:33  wbardwel]
 * 
 * Revision 2.27  94/02/09  21:11:48  wbardwel
 * 	deal with strings.h crap in ultrix
 * 	[94/02/09  21:08:39  wbardwel]
 * 
 * Revision 2.26  94/01/25  04:43:58  wbardwel
 * 	sunos strings.h fix
 * 	[94/01/25  04:42:40  wbardwel]
 * 
 * Revision 2.25  94/01/25  03:41:53  wbardwel
 * 	fix salloc (to match changes in group.c)
 * 	[94/01/25  03:39:16  wbardwel]
 * 
 * Revision 2.24  94/01/21  17:56:14  wbardwel
 * 	fix for HPUX
 * 	[94/01/21  17:55:52  wbardwel]
 * 
 * Revision 2.23  94/01/21  17:43:11  wbardwel
 * 	HPUX fixes
 * 	[94/01/21  17:39:55  wbardwel]
 * 
 * Revision 2.22  94/01/06  04:39:03  wbardwel
 * 	Allow turning off XREF filtering
 * 	[94/01/06  04:29:19  wbardwel]
 * 
 * Revision 2.21  93/12/02  03:28:49  wbardwel
 * 	fixed proto for  Group2ServerListCacheKillAll();
 * 	[93/12/02  03:25:16  wbardwel]
 * 
 * Revision 2.20  93/12/02  00:45:12  wbardwel
 * 	cleanups and stuff added to match changes elsewhere.  (fixed salloc
 * 	for non CMUCS, non STDC )
 * 	[93/12/01  22:02:11  wbardwel]
 * 
 * Revision 2.19  93/11/02  22:58:10  wbardwel
 * 	fix so things compile on rt
 * 	[93/11/02  22:57:54  wbardwel]
 * 
 * Revision 2.18  93/11/02  22:34:21  wbardwel
 * 	fixes for sunos
 * 	[93/11/02  22:00:04  wbardwel]
 * 
 * Revision 2.17  93/10/27  16:02:32  wbardwel
 * 	free_arg() is now a function in parse.c (not a macro)
 * 	add a stage to OpenStage*()
 * 	[93/10/27  15:20:21  wbardwel]
 * 
 * Revision 2.16  93/08/17  17:35:08  wbardwel
 * 	some very modest speedups.
 * 	[93/08/17  17:32:48  wbardwel]
 * 
 * Revision 2.15  93/08/16  14:16:17  wbardwel
 * 	added definition for ContReadFromServerBufNum and
 * 	#define for ContReadFromServer
 * 	[93/08/16  14:14:16  wbardwel]
 * 
 * Revision 2.14  93/08/13  16:33:25  wbardwel
 * 	add declarations for filter.c and STRTOLOWER
 * 	[93/08/13  16:27:57  wbardwel]
 * 
 * Revision 2.13  93/08/10  19:41:04  wbardwel
 * 	[93/08/10  19:28:07  wbardwel]
 * 
 * Revision 2.12  93/08/10  19:19:24  wbardwel
 * 	change allocation sizes, add declaration for var to stuff dnntp_access
 * 	file in (if specified on command line)
 * 
 * Revision 2.11  93/08/05  01:23:24  wbardwel
 * 	include <ctype.h> for STRTOUPPER
 * 	[93/08/05  01:22:01  wbardwel]
 * 
 * Revision 2.10  93/08/05  00:26:06  wbardwel
 * 	add STRTOUPPER to dnntp.h
 * 	[93/08/05  00:23:34  wbardwel]
 * 
 * Revision 2.9  93/08/04  16:36:58  wbardwel
 * 	performance tunes of allocation units
 * 	do defines and declares for redo of break_args and freinds
 * 	[93/08/04  00:09:54  wbardwel]
 * 
 * Revision 2.8  93/07/30  15:53:06  wbardwel
 * 	changed char used for state in server structure back to ints
 * 	[93/07/30  15:51:47  wbardwel]
 * 
 * Revision 2.7  93/07/28  13:25:17  wbardwel
 * 	added declarations for multistage open stuff
 * 	fiddled types for groupfile_array
 * 	[93/07/28  13:00:09  wbardwel]
 * 
 * Revision 2.6  93/07/21  22:41:06  wbardwel
 * 	declaration from ClearServer (which was just added)
 * 	[93/07/21  22:32:17  wbardwel]
 * 
 * Revision 2.5  93/07/16  16:21:14  wbardwel
 * 	declarations for new stuff for new commands
 * 	[93/07/16  16:11:15  wbardwel]
 * 
 * Revision 2.4  93/06/23  00:50:25  wbardwel
 * 	cleanup globals and added definitions for disk list cache.
 * 	[93/06/23  00:25:19  wbardwel]
 * 
 * 	minor Expire fix for G2S stuff
 * 	[93/06/16  15:36:22  wbardwel]
 * 
 * Revision 2.3  93/06/11  20:29:55  wbardwel
 * 	quick bug fix about when we expire the G2S cache
 * 	[93/06/11  20:28:30  wbardwel]
 * 
 * Revision 2.2  93/06/02  14:52:00  wbardwel
 * 	Created.
 * 	[93/05/12            wbardwel]
 * 
*/
/*
 * Copyright (c) 1993, 1994 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software_Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */


#ifndef _DNNTP_H
#define _DNNTP_H

#include <stdlib.h>

#include <sys/types.h>
#include <stdio.h>
#ifdef SUNOS
#include <string.h>
#endif /*SUNOS*/
#ifndef USG
#include <strings.h>
#else /*USG*/
#include <string.h>
#endif /*USG*/
#include <ctype.h>
#include <sys/param.h>
#if SYSLOG
#include <syslog.h>
#ifndef LOG_NEWS
#define LOG_NEWS LOG_LOCAL0
#endif /*!defined(LOG_NEWS)*/
#endif /*SYSLOG*/
	/*this should be from nntp/commmon/nntp.h, it has error number
	definitions among other things*/
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#ifdef __hpux
#define _POSIX_SOURCE 1
#include <signal.h>
#endif /*__hpux*/
#include "nntp.h"

#if 0
typedef enum _command_number_t { 
#if AUTH
	AUTHCAP_CMD, AUTHINFO_CMD, AUTHSYS_CMD,
#endif /*AUTH*/
	ARTICLE_CMD, BODY_CMD, GROUP_CMD, HEAD_CMD, HELP_CMD, IHAVE_CMD,
	LAST_CMD, LIST_CMD, NEWGROUPS_CMD, NEWNEWS_CMD, NEXT_CMD, POST_CMD,
	SLAVE_CMD, STAT_CMD
#ifdef XHDR
	,XHDR_CMD
#endif /*XHDR*/
#ifdef XOVER
	,XOVER_CMD
#endif /*XOVER*/
#ifdef XTHREAD
	,XTHREAD_CMD
#endif /*XTHREAD*/
} command_number_t;
#endif /*0*/

	/*internal error returns*/
#define DNNTP_SUCCESS	0	/* your basic success condition*/
#define DNNTP_SIMPLE_ERR (-1)	/*misc normal error*/
	/*couldn't complete, because something was not int setup before hand*/
#define DNNTP_NO_SETUP_ERR (-2)
#define DNNTP_INTERNAL_ERR (-3)	/*some internal corruption*/
#define DNNTP_REMOTE_DIS_ERR (-4)	/* a server disagreed with what we wanted*/
#define DNNTP_REMOTE_GONE_ERR (-4)	/* a server disconnection (semi-fataly)*/
#define DNNTP_LOWEST_ERR	(-4)

	/*variable in main.c*/
#if DEBUG
extern int debug_level;
#endif /*DEBUG*/
extern char *dnntp_access_file;
	/*serve.c*/
extern void server_loop();
	/*access.c*/
	/*real storage in access.c*/
extern char clientname[];
extern char clientaddrstr[];
int remote_auth();
	/*parse.c*/
#define DNNTP_PARSE_INIT_ALLOC 32
#define break_args(command, no_args) break_args_int((command), (no_args), 0)
#define break_firstarg(command) break_args_int((command), NULL, 1)
extern void free_arg();

extern char **break_args_int();
struct cmdent_t {
	char    *cmd_name;
	int     (*cmd_fn)();
};
extern struct cmdent_t cmdtable[];
/* crappy way to do this...*/
#if AUTH
#define ADD_AUTH 3
#else /*!AUTH*/
#define ADD_AUTH 0
#endif /*AUTH*/
#if LISTGROUP
#define ADD_LISTGROUP 1
#else /*!LISTGROUP*/
#define ADD_LISTGROUP 0
#endif /*LISTGROUP*/
#if MODE
#define ADD_MODE 1
#else /*!MODE*/
#define ADD_MODE 0
#endif /*MODE*/
#if XHDR
#define ADD_XHDR 1
#else /*!XHDR*/
#define ADD_XHDR 0
#endif /*XHDR*/
#if XOVER
#define ADD_XOVER 1
#else /*!XOVER*/
#define ADD_XOVER 0
#endif /*XOVER*/
#if XTHREAD
#define ADD_XTHREAD 1
#else /*!XTHREAD*/
#define ADD_XTHREAD 0
#endif /*XTHREAD*/
#define NUM_COMMANDS (15+ADD_AUTH+ADD_LISTGROUP+ADD_MODE+ADD_XHDR+ADD_XTHREAD+ADD_XOVER)

	/*servers.c*/
extern int LoadServers();
#define ValidServer(servernumber) (((servernumber) < serv_array_len) && \
	((servernumber) >= 0))

#define OpenServer(servernumber) (ValidServer(servernumber)?((serv_array[(servernumber)].connection == -1)?RealOpenServer((servernumber)):DNNTP_SUCCESS):DNNTP_INTERNAL_ERR)
#define ServerName(servernumber) (ValidServer(servernumber)?serv_array[(servernumber)].hostname:"'Bogus Host'")
/* OpenServer -- open connection to a server (if needed)*/
#define DNNTP_OPEN_STAGES 4
extern int RealOpenServer();
extern int OpenStage1(), OpenStage2(), OpenStage3(), OpenStage4();
extern int (*open_serv_func[DNNTP_OPEN_STAGES])();
#if DO_XREALLY
extern int ServersSuppressXREALLY();
#endif /*DO_XREALLY*/
extern void CloseServer();
extern int SendGroup();
extern int SetGroup();
extern int SendToServer();
#define SimpleSendToServer(i, line) if (ValidServer(i)) fputs((line), serv_array[(i)].connectionfpw)
#define SimpleSendFlush(i) if (ValidServer(i)) fflush(serv_array[(i)].connectionfpw)
extern int ReSendToServer();
extern int ReadFromServer();
extern int ContReadFromServerBufNum();
#define ContReadFromServer(s, b) ContReadFromServerBufNum((s),(b),NNTP_STRLEN+1)
/*int ContReadFromServer();*/
/*currently only used by XTHREAD...*/
#if XTHREAD
extern int ContBinReadFromServer();
#endif /*XTHREAD*/
#define DNNTP_CLOSE_SERVER_CMD	"QUIT\r\n"
extern int QuitAllServers();
extern int ClearServer();
extern void clear_spaces();	/*also used in group.c*/

typedef struct _dservers_t {
	char curgroup[NNTP_STRLEN];
	char lastcommand[NNTP_STRLEN];
	int connection;	/*fd for connection*/
	int port;
	FILE *connectionfpw;
	FILE *connectionfpr;
	char hostname[MAXHOSTNAMELEN+1];
	struct sockaddr_in connection_addr;
	int sentgroup;
#if DNNTP_DISK_LIST_CACHE
	time_t server_down_timeout;
#endif /*DNNTP_DISK_LIST_CACHE*/
#if DO_XREALLY
	int do_xreally;
#endif /*DO_XREALLY*/
#if MODE
	int do_mode;
#endif /*MODE*/
		/*for anyone who might need some temporary state on a
		per-server basis*/
	int misc_state;
#if DNNTP_IDLE_CLOSE
	time_t lastsent;       /* time last command was sent*/
#endif /*DNNTP_IDLE_CLOSE*/
	/*any authinfo needed*/
} dservers_t;
	/*actual storage in servers.c*/
extern dservers_t *serv_array;
extern int serv_array_len;

	/*group.c*/
extern int Group2Server();
extern int Group2ServerItem();
extern void Group2ServerClear();
#define Group2ServerPrep() if (group_array == NULL) RealGroup2ServerPrep(DNNTP_DISK_CACHE_OLD, 1)
extern int RealGroup2ServerPrep();
#define DNNTP_GROUP_INIT_ALLOC 4096
#define DNNTP_GROUP_INC_ALLOC 1024
extern int AddGroup2Server();
extern int Group2ServerSort();
extern void Group2ServerDump();
extern int Group2ServerExpire();
extern int Group2ServerStartAdd();
extern int Group2ServerEndAdd();
#if DNNTP_DISK_LIST_CACHE
extern int Group2ServerListCacheTruncate();
extern int Group2ServerListCacheFetch();
extern int Group2ServerListCacheKillAll();
extern time_t Group2ServerListCacheFresh();
#endif /*DNNTP_DISK_LIST_CACHE*/
extern int RealGroup2ServerPrep();

typedef struct _dgroup_t {
	int server_num;
	char *group;
	char *stuff;
} dgroup_t;
typedef struct _fgroup_t {
	int server_num;
	char *group;
} fgroup_t;
extern time_t group_array_secs;
/* not for use outside group.c*/
extern dgroup_t *group_array;
/* extern int group_array_len;*/
/* extern int group_array_memlen;*/
/* extern int group_array_sortedlen;*/
/* extern int group_array_diskcache;*/

#if DNNTP_USE_GROUP_INFO
#if DNNTP_USE_STATIC_GROUP
extern int LoadGroupFile();
#endif /*DNNTP_USE_STATIC_GROUP*/
extern int Group2ServerFileLookup();
	/*actual storage in group.c*/
#if DNNTP_USE_STATIC_GROUP
extern fgroup_t groupfile_array[];
#else /*!DNNTP_USE_STATIC_GROUP*/
extern fgroup_t *groupfile_array;
#endif /*!DNNTP_USE_STATIC_GROUP*/
extern int groupfile_array_len;
#endif /*DNNTP_USE_GROUP_INFO*/

	/*storage in command.c*/
extern int currentserver;	/*current server we are talking too*/
extern int art_cmd();
extern int date_cmd();
extern int group_cmd();
#if MODE
extern int mode_cmd();
#endif /*MODE*/
#if LISTGROUP
extern int listgroup_cmd();
#endif /*LISTGROUP*/
extern int nextlast_cmd();
extern int slave_cmd();
#if XHDR
extern int xhdr_cmd();
#endif /*XHDR*/
#if XOVER
extern int xover_cmd();
#endif /*XOVER*/
extern int list_cmd();
#if EXTENDED_LIST_ACTIVE
extern int list3_cmd();
#endif /*EXTENDED_LIST_ACTIVE*/

extern int post_cmd();
extern int help_cmd();
extern int ihave_cmd();
#if AUTH
extern int auth_cmd();
#endif /*AUTH*/
extern int newgroups_cmd();
extern int newnews_cmd();
#if XTHREAD
	/* this is for the /r/n./r/n added on to the binary data from xthread*/
#define XTHREAD_PADDING 5
extern int xthread_cmd();
#endif /*XTHREAD*/

	/*post.c*/
	/* lines to allocate each time we allocate*/
#define DO_POST_INC_LINES 16
#define DO_POST_NEWSGROUP_HDR "Newsgroups:"
extern int do_post();
extern int do_post_free_ret();

	/*filter.c*/
#if DNNTP_POSSIBLE_XREF_ODDNESS
extern int send_art_filtered();
extern int xover_filtered();
extern int xhdr_xref_filtered();
#endif /*DNNTP_POSSIBLE_XREF_ODDNESS*/

#define STRTOUPPER(str) \
{\
char *s;\
	for(s = (str); *s; s++)\
	if (islower(*s))\
		(*s) = toupper(*s);\
}
#define STRTOLOWER(str) \
{\
char *s;\
	for(s = (str); *s; s++)\
	if (isupper(*s))\
		(*s) = tolower(*s);\
}

/*if they don't have cmucs stuff ansi_bsearch doesn't make sense*/
#if !defined(CMUCS)
#define ansi_bsearch(_key, _base, _numel, _size, _cmpar) bsearch(_key, _base, _numel, _size, _cmpar)
#endif /*!defined(CMUCS)*/

#if !CMUCS
#ifdef   __STDC__
extern char *concat(const char*, int, ...);
#else   /* __STDC__ */
extern char *concat();
#endif /* __STDC__ */
#endif /*CMUCS*/

#if (defined(USG) && ! defined(__hpux))
#define bcopy(src, dst, size) memmove((dst), (src), (size))
#define bzero(dst, size) memset((dst), '\0', (size))
#endif /*USG && !__hpux*/

#if (defined(ultrix) && defined(__STDC__)) || (defined (USG) && ! defined(__hpux))
#define index(str, ch) strchr((str), (ch))
#define rindex(str, ch)  strrchr((str), (ch))
#endif /*(ultrix && __STDC__) || (USG && !__hpux)*/

#ifndef MAX
#define MAX(a,b) (((b) < (a)) ? (a) : (b))
#endif /*MAX*/
#ifndef MIN
#define MIN(a,b) (((a) > (b)) ? (b) : (a))
#endif /*MIN*/
#endif /*_DNNTP_H*/
