/* dnntpconf.h */
/* configuration file for dnntpd*/
/* Thu Jan 28 14:29:26 EST 1993 wbardwel : created*/
/*note: don't just define things, define them to 1
to turn them on*/
/*
 * HISTORY
 * $Log:	dnntpconf.h,v $
 * Revision 2.37  95/10/31  00:43:19  wbardwel
 * 	to 9n (to match a few minor fixes (umask, find_item, xover stuff))
 * 	[95/10/31  00:41:49  wbardwel]
 * 
 * Revision 2.36  95/02/21  16:40:06  wbardwel
 * 	no version 9m, also added IDLE_CLOSE stuff from noyd@u.washington.edu
 * 	And make DNNTP_PORT useful, for setting a static port to listen on...
 * 	[95/02/21  16:33:28  wbardwel]
 * 
 * Revision 2.35  95/01/09  00:45:42  wbardwel
 * 	change to 9l
 * 	[95/01/09  00:42:11  wbardwel]
 * 
 * Revision 2.34  95/01/05  13:57:44  wbardwel
 * 	up to 9k
 * 	[95/01/05  13:27:59  wbardwel]
 * 
 * Revision 2.33  94/12/15  00:44:49  wbardwel
 * 	up version to 9j for mild fixes and "LIST ACTIVE <grouppat>" support
 * 	[94/12/15  00:32:09  wbardwel]
 * 
 * Revision 2.32  94/07/12  17:26:43  wbardwel
 * 	update copyright
 * 	[94/07/12  17:22:05  wbardwel]
 * 
 * Revision 2.31  94/06/14  18:01:44  wbardwel
 * 	make version 0.9i (propogate list_cmd fixes to copies of same code)
 * 	[94/06/14  17:56:03  wbardwel]
 * 
 * Revision 2.30  94/06/03  16:20:10  wbardwel
 * 	make version .9h (fix select stuff in LIST)
 * 	[94/06/03  16:18:32  wbardwel]
 * 
 * Revision 2.29  94/05/27  17:21:12  wbardwel
 * 	update to version .9g (fiddling with xover code)
 * 	[94/05/27  17:18:56  wbardwel]
 * 
 * Revision 2.28  94/05/26  04:37:53  wbardwel
 * 	update to version .9e (with select fixes for old dnntpds...)
 * 	[94/05/26  04:37:33  wbardwel]
 * 
 * Revision 2.27  94/05/17  04:36:46  wbardwel
 * 	update to version .9e (posting code re-write)
 * 	[94/05/17  04:34:03  wbardwel]
 * 
 * Revision 2.26  94/04/21  01:48:56  wbardwel
 * 	update version string to .9d, turnoff AMS kludge, make
 * 	dangerous LIST caching configurable (and off)
 * 	[94/04/21  01:45:02  wbardwel]
 * 
 * Revision 2.25  94/04/07  00:31:14  wbardwel
 * 	fix SYSTEM_STRDUP for alpha
 * 	[94/04/07  00:28:58  wbardwel]
 * 
 * Revision 2.24  94/03/29  17:07:20  wbardwel
 * 	update version number to .9c and fix sunos paths
 * 	[94/03/29  17:04:45  wbardwel]
 * 
 * Revision 2.23  94/03/22  17:43:10  wbardwel
 * 	change to version number .9b for changes to fix problems on server outages
 * 	[94/03/22  17:39:32  wbardwel]
 * 
 * Revision 2.22  94/03/09  23:31:53  wbardwel
 * 	bump version to .9a (posting fixes...)
 * 	[94/03/09  23:31:07  wbardwel]
 * 
 * Revision 2.21  94/02/21  23:49:16  wbardwel
 * 	now version .9
 * 	[94/02/21  23:48:59  wbardwel]
 * 
 * Revision 2.20  94/02/21  22:56:10  wbardwel
 * 	go to non-static grouping...
 * 	[94/02/21  22:54:10  wbardwel]
 * 
 * Revision 2.19  94/02/09  21:11:59  wbardwel
 * 	ultrix config stuff
 * 	[94/02/09  21:09:37  wbardwel]
 * 
 * Revision 2.18  94/01/25  04:44:02  wbardwel
 * 	strdup/salloc fix
 * 	[94/01/25  04:42:55  wbardwel]
 * 
 * Revision 2.17  94/01/25  03:41:58  wbardwel
 * 	HPUX patches
 * 	[94/01/25  03:38:49  wbardwel]
 * 
 * Revision 2.16  94/01/21  17:43:18  wbardwel
 * 	HPUX fixes
 * 	[94/01/21  17:40:20  wbardwel]
 * 
 * Revision 2.15  94/01/06  04:50:31  wbardwel
 * 	change to version .8b since two sets of bug fixes since 8a
 * 	[94/01/06  04:49:49  wbardwel]
 * 
 * Revision 2.14  94/01/06  04:39:18  wbardwel
 * 	fix typos, add DNNTP_POSSIBLE_XREF_ODDNESS to control XREF filtering
 * 	[94/01/06  04:30:48  wbardwel]
 * 
 * Revision 2.13  93/12/14  17:54:24  wbardwel
 * 	fixed dnntp_conf paths...(for alpha and sunos), turn on MAYBE_ROOT for
 * 	SUNOS
 * 	[93/12/14  17:53:13  wbardwel]
 * 
 * Revision 2.12  93/12/06  03:18:09  wbardwel
 * 	make version number .8a since this is .8 with fixs
 * 	[93/12/06  03:14:54  wbardwel]
 * 
 * Revision 2.11  93/12/02  00:45:25  wbardwel
 * 	fix DNNTP_DOWN_SERVER_TIME
 * 	[93/12/02  00:19:24  wbardwel]
 * 
 * 	added support for AIX, added DNNTP_SERVER_DOWN_TIMEOUT
 * 	[93/12/01  22:03:42  wbardwel]
 * 
 * Revision 2.10  93/11/02  22:34:37  wbardwel
 * 	fixes and new config options for sunos and alphas.
 * 	[93/11/02  21:59:09  wbardwel]
 * 
 * Revision 2.9  93/10/27  16:02:39  wbardwel
 * 	small "bug" fixes, change LIST cache timeout to 4:59 min, to match
 * 	xrn(5 min).  add things for new list_cmd();
 * 	[93/10/27  15:21:45  wbardwel]
 * 
 * Revision 2.8  93/08/10  19:19:33  wbardwel
 * 	turn off XTHREAD (hey, it doesn't work...)
 * 	[93/08/10  19:15:08  wbardwel]
 * 
 * Revision 2.7  93/07/28  13:32:45  wbardwel
 * 	fixed typo
 * 	[93/07/28  13:29:48  wbardwel]
 * 
 * Revision 2.6  93/07/28  13:25:22  wbardwel
 * 	added definitions for stuff to change uids (from root to whatever)
 * 	added definitions for checking if disc cache is fresh.
 * 	changed in memory cache to be updated every 11 min.
 * 
 * Revision 2.5  93/07/21  22:41:12  wbardwel
 * 	added DNNTP_CMU_ANDREW_KLUDGE config option.
 * 	added define for what localhost addr looks like
 * 	[93/07/21  22:33:51  wbardwel]
 * 
 * Revision 2.4  93/07/16  16:21:21  wbardwel
 * 	up version string, turn on MODE and LISTGROUP commands
 * 	[93/07/16  16:11:37  wbardwel]
 * 
 * Revision 2.3  93/06/23  00:50:32  wbardwel
 * 	added defines for disk list cache
 * 	[93/06/23  00:25:52  wbardwel]
 * 
 * Revision 2.2  93/06/02  14:52:17  wbardwel
 * 	Created.
 * 	[93/01/28            wbardwel]
 * 
*/
/*
 * Copyright (c) 1993,1994 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software_Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */


#ifndef _DNNTP_CONFIGURE_H
#define _DNNTP_CONFIGURE_H

/*NOTE: if a #ifdef thingy in source, isn't mentioned in here, you
probably shouldn't be screwing with it*/

#define DNNTP_VERSION_STR "0.9n(dnntp)"

#define DEBUG 1

	/*note: LOCAL_ONLY probably doesn't work (never been run...)*/
	/*LOCAL_ONLY(ie Un*x domain socket) or remote(ie INET family socket)*/
#define LOCAL_ONLY 0
#if LOCAL_ONLY
#define DNNTP_SOCKET_NAME	"/tmp/dnntp_sock"
#else /*!LOCAL_ONLY*//*remote*/
	
/*#define DNNTP_PORT 119*/	/*if not set, currently looked up with
	getservbyname()*/
#endif /*LOCAL_ONLY*/
	/* should we use the XREALLY command to make it reasonable for other
	us to accept connections from something other than the local host*/
#define DO_XREALLY 1
	/* kludge to always send xreally's (even if localhost connection)
	so nntp servers can tell we are the forwarder (and turn on cmu.andrew
	for us)*/
#define DNNTP_CMU_ANDREW_KLUDGE 0

	/* allow "dumb" hosts to use the forwarder (ie hosts that aren't running
	the forwarder for whatever reason)(NOTE: double the net traffic, double
	the fun!)*/
#define DNNTP_ALLOW_OUTSIDE 1
#if DNNTP_ALLOW_OUTSIDE
#define DNNTP_OUTSIDE_ALLOWED_FILE "/etc/dnntp_access"
#endif /*DNNTP_ALLOW_OUTSIDE*/
#if DO_XREALLY && !DNNTP_ALLOW_OUTSIDE
#error "XREALLY not useful unless you allow other hosts through dnntp"
#endif

	/*turnon all the extra commands that we want...*/
#define XHDR 1
#define XOVER 1
	/*this turns on "LIST ACTIVE <group name>"*/
	/*if you are gonna turn this off, take wildmat.o and list3_cmd.o
	out of the OBJ file list, cause you don't need them*/
#define EXTENDED_LIST_ACTIVE 1

	/* doesn't really effect much...(never really should be on)*/
#define XHDR_EXT 0
	/* damn, doesn't really work...*/
#define XTHREAD 0
#define AUTH 1
#define MODE 1
/*set to -1 if servers might or might not want "MODE READER" command,
if all backing servers are INN or such, set to 1 (so it does MODE)
set it to 0, and you might as well have not enabled it*/
#define DNNTP_INIT_MODE_VAL -1
#define LISTGROUP 1
	/* if nntp servers (all of them) are consistant about contents of
	groups without intervening LIST commands turn this on...*/
#define DNNTP_SERVER_CONSISTANT_WO_LISTS 0

	/*turn on running alone (not under inetd) for running under nanny*/
	/*ie now under inetd*/
#if !defined (CMUCS) || defined(SUNOS) || defined(__alpha) || defined(AIX) || defined(__hpux) ||defined (ultrix)
#define ALONE 0
#else
#define ALONE 1
#endif /*defined(SUNOS) || defined(__alpha) || defined(AIX) || defined(__hpux)*/
#if LOCAL_ONLY && !ALONE
#error "You can't run on a Unix domain socket and under inetd."
#endif /* LOCAL_ONLY && !ALONE */

#if ALONE
	/*yes, we are running under nanny!*/
#define NOT_RUNNING_UNDER_NANNY 0
#endif /*ALONE*/
	/*enable bonus loging (not enough of it...)*/
#define LOG 1
	/*we have syslog, lets use it*/
#define SYSLOG 1
#if SYSLOG
	/*what are we calling ourselves to syslog?*/
#define DNNTP_SYSLOG_ID "dnntpd"
#endif /*SYSLOG*/
		/* the number that each DEBUG_*PRINT is defined to (if not 0)
		is the number of SIGUSR1's that need to be sent to really
		make it happen*/
	/*syslog commands we get as they go by?*/
#define DEBUG_CMD_PRINT 1
	/*syslog remote commands we send as they go by?*/
#define DEBUG_REMOTE_CMD_PRINT 2
	/*syslog remote replys as they go by?*/
#define DEBUG_REMOTE_REP_PRINT 3
#if DEBUG_CMD_PRINT || DEBUG_REMOTE_CMD_PRINT || DEBUG_REMOTE_REP_PRINT
#if !SYSLOG
#error "the DEBUG_*CMD_PRINT* options only make sense if you have SYSLOG"
#endif
#if !DEBUG
#error "need DEBUG turned on to get the run-time signal code(to turn on mesgs)"
#endif /*!DEBUG*/
#endif /*DEBUG_CMD_PRINT || DEBUG_REMOTE_CMD_PRINT || DEBUG_REMOTE_REP_PRINT*/

	/*what is our net services identity*/
#define DNNTP_SERVICE_ID "nntp"

	/* what uid we would like to be running as */
#define DNNTP_UID_NAME "news"
	/* what we consider root's uid to be*/
#define DNNTP_ROOT_UID 0
	/* could we have been run as root?*/
#define DNNTP_MAYBE_ROOT 1
	/* what environment variable should we look at to decide where
	to consider a tmpdir (for us to live in)*/
#define DNNTP_TMP_ENVVAR "TMPDIR"
	/* what can be safely opened where ever (and won't fail), used
	as a place holder on fds*/
#define DNNTP_DEV_NULL "/dev/null"

#if defined(CMUCS)
	/*locations of setup(config) files*/
#define DNNTP_SERVERS_FILE	"/usr/misc/.netnews/lib/dnntp_conf"
#else
#define DNNTP_SERVERS_FILE	"/usr/local/lib/dnntp_conf"
#endif /*!(CMUCS || defined(SUNOS))*/
	/* use group stuff to figure out which server a group is on*/
#define DNNTP_USE_GROUP_INFO 0

	/* group info is compiled in, not in a config file*/
	/* if 0 it is read from a file*/
#if DNNTP_USE_GROUP_INFO
#define DNNTP_USE_STATIC_GROUP 1
#endif /*DNNTP_USE_GROUP_INFO*/

#if DNNTP_USE_GROUP_INFO && !DNNTP_USE_STATIC_GROUP
#define DNNTP_GROUP_FILE	"/etc/dnntp_groups"
#endif /*DNNTP_USE_GROUP_INFO && !DNNTP_USE_STATIC_GROUP*/

	/* turn on filtering of articles, xovers and xhdr headers so that
	articles which appear to be crossposted across servers don't
	hose things (because of article number dissagreements)*/
	/*should be safe to turn off once all articles that were cross
	posted before going to multi server model have expired (and
	moveing groups should be safe with this off, if no duplicated
	groups)*/
#define DNNTP_POSSIBLE_XREF_ODDNESS 1

	/* turn on saving old list information in the home dir of whoever
	dnntpd runs as*/ /*this will minimize harm from downed servers*/
#define DNNTP_DISK_LIST_CACHE 1
#if DNNTP_DISK_LIST_CACHE
	/* base name of files to use*/
#define DNNTP_DISK_LIST_CACHE_NAME "listcache"
	/* how old must the disk cache files be before we call them old*/
		/* 2.5 days...(in seconds)*/
#define DNNTP_DISK_CACHE_OLD ((long)(24*60*60*2.5))
#endif /*DNNTP_DISK_LIST_CACHE*/
	/* size of buffers to use when reading in LIST data (remeber one
	per server will be allocated)*/
/*#define DNNTP_LIST_MEMBUFSIZE 16384*/
#define DNNTP_LIST_MEMBUFSIZE 4096
	/* should we try to make the buffer we pass in on reads, page aligned?*/
#define DNNTP_LIST_MEMBUF_PAGEALIGN 1
#if DNNTP_LIST_MEMBUF_PAGEALIGN
	/*should be some aprox number to use to make sure we have some
	extra space in a buffer (ie big enough to hold a line from the list
	command, but still be page aligned*/
/*#define DNNTP_LIST_MEMPAGESIZE 8192*/
#define DNNTP_LIST_MEMPAGESIZE 4096
#if (DNNTP_LIST_MEMBUFSIZE%DNNTP_LIST_MEMPAGESIZE != 0)
#error "buffer size must be a multiple of a page size for this to work out"
#endif
#endif /*DNNTP_LIST_MEMEBUF_PAGEALIGN*/

	/*the string that the servers send on a timeout (not case sensitive)
	and what we will send on timeouts (if we do timeouts...)*/
#define DNNTP_TIMEOUT_STR "503 Timeout"
#define DNNTP_TIMEOUT_STRLEN 11

	/*maximum length of a group name (or partial group name)*/
#define DNNTP_GROUP_STRLEN 256

	/* address to complain about this software */
#define DNNTP_TROUBLE_EMAIL "help@cs.cmu.edu"
	/* how long to we beleive our saved data from LISTs are good (in secs)*/
	/*time from when we start LIST command...(not end of it)*/
#define DNNTP_LIST_CACHE_TIME ((4*60)+59)	/*4:59 minutes(so xrn rescans work*/
	/*how long we expect real servers to be down (ie won't retry a
	connection until this amount of time has passed*/
#define DNNTP_SERVER_DOWN_TIMEOUT (4*60)	/*4:00 minutes*/

	/* what does a string of the localhost address look like*/
#define DNNTP_LOCALHOST_STR "127.0.0.1"
	/*does system provide a strdup? (if not we will...)*/
#if defined(__hpux) || defined(SUNOS) || defined(__alpha)
#define SYSTEM_STRDUP 1
#endif /*defined(__hpux) || defined(SUNOS) || defined(__alpha)*/

	/* Close connections to servers if idle this many seconds. */
	/* Set to 0 or undefine to disable check */
/*#define DNNTP_IDLE_CLOSE 180*/
	/* The idle connection close timeout check may be set to only occur if
	   the client connection is also idle.  Set to 0 to enforce strict
	   timeout of idle server connections, otherwise set higher to give
	   grace to active clients who may use those idle connections in the
	   near future.   This should be set to less than the Pine polling
	   frequency.
	*/
/*#define DNNTP_IDLE_CLIENT 60*/

#endif /*_DNNTP_CONFIGURE_H*/
