/*list3_cmd.c*/
/*implement "LIST ACTIVE <group name>" stuff...*/
/*
 * HISTORY
 * $Log:	list3_cmd.c,v $
 * Revision 2.7  95/03/03  17:20:44  wbardwel
 * 	minor fix in find_item to set the lower bound...opps
 * 	[95/03/03  17:15:49  wbardwel]
 * 
 * Revision 2.6  95/01/09  22:43:40  wbardwel
 * 	added copyright
 * 	[95/01/09  22:42:11  wbardwel]
 * 
 * Revision 2.5  95/01/09  00:46:06  wbardwel
 * 	let list_cmd do our init crap
 * 	[95/01/09  00:43:49  wbardwel]
 * 
 * Revision 2.4  95/01/01  23:20:53  wbardwel
 * 	don't set cache time...prep does that
 * 	[95/01/01  23:19:11  wbardwel]
 * 
 * Revision 2.3  94/12/15  01:30:27  wbardwel
 * 	cleanup/bug fixes
 * 	[94/12/15  01:29:54  wbardwel]
 * 
 * Revision 2.2  94/12/15  00:45:11  wbardwel
 * 	initial version
 * 	[94/12/15  00:39:45  wbardwel]
 * 
*/
/*
 * Copyright (c) 1994, 1995 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software_Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

#include "dnntpconf.h"
#include "dnntp.h"
#include <sys/time.h>

#if EXTENDED_LIST_ACTIVE
extern dgroup_t *group_array;
extern int group_array_len;
static int find_item();

int list3_cmd(args, no_args)
char *args[];
int no_args;
{
struct timeval tv;
	if (strcasecmp(args[1], "ACTIVE") || (no_args != 3)) {
		printf("%d Usage: LIST [ACTIVE [newsgroup]|NEWSGROUPS|\
DISTRIBUTIONS].\r\n", ERR_CMDSYN);
		(void) fflush(stdout);
		return(DNNTP_SIMPLE_ERR);
	}
	if (Group2ServerPrint(args[2], stdout) < 0) {
		int s, e;
		char tmp_ch, *pat;
		pat = args[2];
		while (*pat && (*pat != '*') && (*pat != '[') &&
			(*pat != '?'))
			pat++;
		if (!*pat)
			goto done;
		if (pat == args[2]) {
			s = 0;
			e = group_array_len-1;
		} else {
			tmp_ch = *pat;
			*pat = '\0';
			s = find_item(args[2]);
			if (s < 0)
				s = 0;
			(*(pat-1))++;
			e = find_item(args[2]);
			if (e < 0)
				e = group_array_len-1;
			(*(pat-1))--;
			*pat = tmp_ch;
		}
		for (; s <= e; s++) {
			if (wildmat(group_array[s].group, args[2])) {
				fputs(group_array[s].group, stdout);
				putc(' ', stdout);
				fputs(group_array[s].stuff, stdout);
				putc('\r', stdout);
				putc('\n', stdout);
			}
		}
	
	}
done:
	putc('.', stdout);
	putc('\r', stdout);
	putc('\n', stdout);
	fflush(stdout);
	return(DNNTP_SUCCESS);
}

/* stolen from bsearch in libcs
 * Copyright (c) 1990,1994 Carnegie Mellon University
 * All Rights Reserved.
*/
static int find_item(str)
char *str;
{
int l=0, u = group_array_len-1, m, r;
	/* Invariant: key > all elements in [0..l) and key < all elements in
       (u..nel-1]. */
    while (l <= u) {
        m = (l + u) / 2;
        r = strcmp(str, group_array[m].group);
        if (r == 0)
            return m;
        else if (r < 0)
            u = m - 1;
        else
            l = m + 1;
    }
    return u;                   /* Which should == l - 1 */
}

#endif /*EXTENDED_LIST_ACTIVE*/
