/* main.c*/
/* main routine for dnntpd
handles inetd or running alone, and setting up client->server
connections*/
/* Thu Jan 28 14:25:14 EST 1993 wbardwel: created*/
/*note: loosely based on main.c from nntp/server*/
/*
 * HISTORY
 * $Log:	main.c,v $
 * Revision 2.24  95/10/17  18:13:11  wbardwel
 * 	fix umask (it was making files writable by og...)
 * 	[95/10/17  18:12:24  wbardwel]
 * 
 * Revision 2.23  95/02/21  16:40:19  wbardwel
 * 	fixed typos, and make DNNTP_PORT usable to set a static port.
 * 	[95/02/21  16:35:23  wbardwel]
 * 
 * Revision 2.22  94/10/25  18:17:07  wbardwel
 * 	use SOMAXCONN with listen, not 5
 * 	[94/10/25  18:15:40  wbardwel]
 * 
 * Revision 2.21  94/07/12  17:27:13  wbardwel
 * 	update copyright, fix for svr4
 * 	[94/07/12  17:23:38  wbardwel]
 * 
 * Revision 2.20  94/06/14  18:02:14  wbardwel
 * 	remove redundant inclusion of in.h
 * 	[94/06/14  17:58:20  wbardwel]
 * 
 * Revision 2.19  94/05/26  04:35:24  wbardwel
 * 	misc maybe fix
 * 	[94/05/26  04:34:27  wbardwel]
 * 
 * Revision 2.18  94/04/07  00:31:22  wbardwel
 * 	fix BSD_42 (to bsd4_2) ifdef so works without intervention
 * 	[94/04/07  00:29:39  wbardwel]
 * 
 * Revision 2.17  94/03/02  16:24:21  wbardwel
 * 	fix -c
 * 	[94/03/02  16:23:28  wbardwel]
 * 
 * Revision 2.16  94/03/02  16:10:07  wbardwel
 * 	add -c option
 * 	[94/03/02  16:09:05  wbardwel]
 * 
 * Revision 2.15  94/02/09  21:12:03  wbardwel
 * 	fix some problems with ultrix
 * 	[94/02/09  21:10:11  wbardwel]
 * 
 * Revision 2.14  94/01/25  03:42:16  wbardwel
 * 	fix screwy endif
 * 	[94/01/25  03:34:38  wbardwel]
 * 
 * Revision 2.13  94/01/21  17:43:40  wbardwel
 * 	fixes for HPUX (and other sysv)
 * 	[94/01/21  17:41:37  wbardwel]
 * 
 * Revision 2.12  93/12/14  17:54:28  wbardwel
 * 	fix MAYBE_ROOT stuff so it works for things running under inetd (shouldn't
 * 	be needed then, but...)
 * 	[93/12/14  17:53:47  wbardwel]
 * 
 * Revision 2.11  93/12/02  00:46:06  wbardwel
 * 	fixed -f flag for non ALONE version (from Andy Gruss <gruss@cs.cmu.edu>)
 * 	[93/12/01  21:57:25  wbardwel]
 * 
 * Revision 2.10  93/11/02  22:35:18  wbardwel
 * 	include fixes, bug fixes for sunos
 * 	[93/11/02  22:02:31  wbardwel]
 * 
 * Revision 2.9  93/10/27  16:02:56  wbardwel
 * 	do better clean up on exit, added (unsupported) ability to use
 * 	gprof if you define DO_PROF
 * 	[93/10/27  15:25:06  wbardwel]
 * 
 * Revision 2.8  93/08/13  16:33:38  wbardwel
 * 	clear out bogus exit declaration
 * 	[93/08/13  16:28:37  wbardwel]
 * 
 * Revision 2.7  93/08/10  19:41:09  wbardwel
 * 	bug fixes for command line stuff
 * 	[93/08/10  19:40:14  wbardwel]
 * 
 * Revision 2.6  93/08/10  19:19:46  wbardwel
 * 	add support for command line flags...
 * 	[93/08/10  19:16:37  wbardwel]
 * 
 * Revision 2.5  93/08/04  16:37:55  wbardwel
 * 	add definition of exit()
 * 	[93/08/04  00:12:28  wbardwel]
 * 
 * Revision 2.4  93/07/28  16:19:11  wbardwel
 * 	another warning fix for gcc (on OSF)
 * 	[93/07/28  16:18:09  wbardwel]
 * 
 * Revision 2.3  93/07/28  13:25:43  wbardwel
 * 	added code to change uids if we were run as root
 * 	added code to try an cd somewhere nice (like /tmp or such) so
 * 	core dumps and such are local
 * 	[93/07/28  13:20:03  wbardwel]
 * 
 * Revision 2.2  93/06/02  14:52:33  wbardwel
 * 	Created.
 * 	[93/01/28            wbardwel]
 * 
*/
static char copyright_string[] = "Copyright (c) 1993, 1994 Carnegie Mellon University\nAll Rights Reserved.\n";
/*
 * Copyright (c) 1993, 1994 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software_Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */


	/*need this order of dnntp files*/
#include "dnntpconf.h"
#include "dnntp.h"

/*#include <sys/socket.h> done in dnntp.h*/
/*#include <netdb.h> done in dnntp.h*/
#if !LOCAL_ONLY
#include <arpa/inet.h>
#else /*LOCAL_ONLY*/
#include <sys/un.h>
#endif /*LOCAL_ONLY*/
#include <signal.h>
#include <sys/ioctl.h>
#include <sys/param.h>
#include <errno.h>
#include <sys/file.h>	/*for open() stuff*/
#if DNNTP_MAYBE_ROOT
#include <pwd.h>
static int turn_to_news();
#endif /*DNNTP_MAYBE_ROOT*/

#if ALONE && !defined(USG)
	/*all these for wait3() in Baby_killer*/
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>
	/*routine we will use to clean up after children*/
#ifdef ultrix
static void baby_killer();
#else /*!ultrix*/
static int baby_killer();
#endif /*!ultrix*/
#endif /*ALONE && !defined(USG)*/

#if DEBUG
int debug_level=0;
static void debugup();
static void debugdown();
#endif /*DEBUG*/
#if DNNTP_DISK_LIST_CACHE
static char usage_str[] = "usage: dnntpd -d <starting debuging level>\n\t\
-f <dnntp_conf file path>\n\t-a <dnntp_access file path>\n\t\
-c <directory to put cache files in>\n";
#else /*!DNNTP_DISK_LIST_CACHE*/
static char usage_str[] = "usage: dnntpd -d <starting debuging level>\n\t\
-f <dnntp_conf file path>\n\t-a <dnntp_access file path>\n";
#endif /*!DNNTP_DISK_LIST_CACHE*/

char *dnntp_conf_file = NULL;
char *dnntp_access_file = NULL;

#if ALONE
int setup_server_socket();
void make_stdio();
void disassoc();
#endif /*ALONE*/

int main( argc, argv )
int argc;
char *argv[];
{
#if ALONE	/*if no inetd*/
#if TESTING
	int fds;	/*used as temp var*/
#endif /*TESTING*/
	int s;		/*used to hold server socket fd*/
#endif /*ALONE*/
#if DNNTP_DISK_LIST_CACHE
	extern char tmpfilestr[];
	extern size_t tmpfile_strlen;
#endif /*DNNTP_DISK_LIST_CACHE*/

	if (argc > 1) {
	int i = 1;
		for(i = 1; i < argc; i++)
			if ((argv[i][0] == '-') && ((i+1) < argc)){
				switch (argv[i][1]) {
					case 'd':
#if DEBUG
						debug_level = atoi(argv[++i]);
#else /*!DEBUG*/
						fputs("-d not supported since\
this was compiled without debugging\n", stderr);
#endif /*!DEBUG*/
						break;
					case 'f':
						dnntp_conf_file = argv[++i];
						break;
					case 'a':
						dnntp_access_file = argv[++i];
						break;
#if DNNTP_DISK_LIST_CACHE
					case 'c':
						strcpy(tmpfilestr, argv[++i]);
#ifndef __STDC__
						strcat(tmpfilestr, "/");
				strcat(tmpfilestr, DNNTP_DISK_LIST_CACHE_NAME);
						strcat(tmpfilestr, ".");
#else /*!__STDC__*/
						strcat(tmpfilestr,
					"/" DNNTP_DISK_LIST_CACHE_NAME ".");
#endif /*!__STDC__*/
						tmpfile_strlen =
							strlen(tmpfilestr);
						break;
#endif /*DNNTP_DISK_LIST_CACHE*/
					default:
						fputs(usage_str, stderr);
						exit(2);
				}
			} else {
				fputs(usage_str, stderr);
				exit(2);
			}
	}
#if ALONE	/*if no inetd*/
#if !TESTING
#ifndef DO_PROF
	disassoc();	/*daemonize*/
#endif /*!DO_PROF*/
	/*note: fd 0-2 will point to "/" as part of disassoc()*/
		/*close all fds if didn't disassoc()*/
#else /*TESTING*/
		/*note: NOFILE doesn't acuratily reflect number of fds*/
		/*but we expect to chatch most/enough this way*/
	for(fds=3; fds< NOFILE; fds++)
		(void) close(fds);
#endif /*TESTING*/
#else /*!ALONE*/	/*from inetd*/
		/*some inetds don't put everything on fds 1 and 2 (acording to
		nntp/server/serve.c*/
	(void) close(1);
	(void) close(2);
	(void) dup(0);	/*ends up on fd 1*/
	(void) dup(0);	/*ends up on fd 2*/
#endif /*ALONE*/
#if SYSLOG
#if defined(bsd4_2)
	openlog(DNNTP_SYSLOG_ID, LOG_PID);
#else	/*!defined(bsd4_2)*/
	openlog(DNNTP_SYSLOG_ID, LOG_PID, LOG_NEWS);
#endif /*!defined(bsd4_2)*/
#endif /*SYSLOG*/
	{
	char *tmpdir;
	if (((tmpdir = getenv(DNNTP_TMP_ENVVAR)) == NULL) || (chdir(tmpdir) < 0))
		if (chdir("/tmp") < 0)
			if (chdir("/usr/tmp") < 0)
				if (chdir("/") < 0) {
#if SYSLOG
					if (tmpdir)
						syslog(LOG_ERR, "couldn't cd to\
 %s or /tmp or /usr/tmp or / : %m", tmpdir);
					else
						syslog(LOG_ERR, "couldn't cd \
 /tmp or /usr/tmp or / : %m");
#endif /*SYSLOG*/
				}
	}

#if ALONE	/*if no inetd(we need to clean up our children)*/
	/*set things up to cleanup after children*/
#if defined(USG)
	(void) signal(SIGCHLD, SIG_IGN);
#else /*!defined(USG)*/
	(void) signal(SIGCHLD, baby_killer);
#endif /*!defined(USG)*/
#else /*!ALONE*/	/*under inetd, no children*/
#if defined(USG)
	(void) signal(SIGCHLD, SIG_DFL);
#endif /*defined(USG)*/
#endif /*!ALONE*/
#if DEBUG
	(void) signal(SIGUSR1, debugup);
	(void) signal(SIGUSR2, debugdown);
#endif /*DEBUG*/

	/*do all of the alone stuff to start up server net stuff*/
#if ALONE	/*if no inetd*/
	s = setup_server_socket();
	if (s < 0)	/*shouldn't happen*/
		exit(1);
	/* we have the server socket, so lets turn into news if need be*/
#endif /*ALONE*/
#if DNNTP_MAYBE_ROOT
	if (turn_to_news() < 0) {
#if SYSLOG
			syslog(LOG_ERR, "couldn't change uid's from root to %s:\
 %m", DNNTP_UID_NAME);
#endif /*SYSLOG*/
	}
#endif /*DNNTP_MAYBE_ROOT*/
#if ALONE	/*if no inetd*/
		/*now do main loop waiting for clients*/
	for(;;){
#if LOCAL_ONLY
		struct sockaddr_un client_addr;
#else /*!LOCAL_ONLY*/
		struct sockaddr_in client_addr;
#endif /*!LOCAL_ONLY*/
		int clientfd, addr_length;
		addr_length = sizeof(client_addr);
		clientfd = accept(s, &client_addr, &addr_length);
		if (clientfd < 0) {
#if SYSLOG
			if (errno != EINTR)
				syslog(LOG_ERR, "accept: %m");
#endif /*SYSLOG*/
			errno = 0;
			continue; /*do loop again...*/
		}
#ifdef DO_PROF
		switch (0) {
#else /*!DO_PROF*/
		switch (fork()) {
#endif /*!DO_PROF*/
			case -1:
#if SYSLOG
				syslog(LOG_ERR, "fork for client connection: %m");
#endif /*SYSLOG*/
				(void) close(clientfd);
			break;
			case 0:
				(void) close(s);
				make_stdio(clientfd);
#ifdef USG
				(void) signal(SIGCHLD, SIG_DFL);
#endif /*USG*/
				/*load everything (copied also in non-ALONE)*/
				if (LoadServers(dnntp_conf_file?
					dnntp_conf_file:DNNTP_SERVERS_FILE)
					< 0) {
#if SYSLOG
					syslog(LOG_ERR, "quiting since error \
getting servers file");
#endif /*SYSLOG*/
					printf("%d unable to load %s (the list \
of real servers)\r\n", ERR_FAULT, dnntp_conf_file?dnntp_conf_file:
DNNTP_SERVERS_FILE);
					(void) fflush(stdout);
					exit(1);
				}
#if DNNTP_USE_GROUP_INFO && !DNNTP_USE_STATIC_GROUP
				if (LoadGroupFile(DNNTP_GROUP_FILE) < 0) {
#if SYSLOG
					syslog(LOG_ERR, "quiting since error \
getting groups file");
#endif /*SYSLOG*/
					printf("%d unable to load %s (the \
group to server regex file) of real servers)\r\n", ERR_FAULT, DNNTP_GROUP_FILE);
					(void) fflush(stdout);
					exit(1);
				}
#endif /*DNNTP_USE_GROUP_INFO && !DNNTP_USE_STATIC_GROUP*/

				server_loop();	/*real work*/
					/* should have some real cleanup...*/
#ifdef DO_PROF
				/*do_times();*/
#endif /*DO_PROF*/
				fclose (stdin);
				fclose (stdout);
				fclose (stderr);
				QuitAllServers();
				Group2ServerClear();
				exit (0);
			break;
			default:
				(void) close(clientfd);
			break;
		}
	}
#else /*!ALONE*/
	/*load everything(also in ALONE code above)*/
	if (LoadServers(dnntp_conf_file?dnntp_conf_file:DNNTP_SERVERS_FILE)
		< 0) {
#if SYSLOG
		syslog(LOG_ERR, "quiting since error getting servers file");
#endif /*SYSLOG*/
		printf("%d unable to load %s (the list of real servers)\r\n",
			ERR_FAULT,
			dnntp_conf_file?dnntp_conf_file:DNNTP_SERVERS_FILE);
		(void) fflush(stdout);
		exit(1);
	}
#if DNNTP_USE_GROUP_INFO && !DNNTP_USE_STATIC_GROUP
	if (LoadGroupFile(DNNTP_GROUP_FILE) < 0) {
#if SYSLOG
		syslog(LOG_ERR, "quiting since error getting groups file");
#endif /*SYSLOG*/
		printf("%d unable to load %s (the group to server regex file) \
of real servers)\r\n", ERR_FAULT, DNNTP_GROUP_FILE);
		(void) fflush(stdout);
		exit(1);
	}
#endif /*DNNTP_USE_GROUP_INFO && !DNNTP_USE_STATIC_GROUP*/

		/*do real serving*/
	server_loop();
	fclose (stdin);
	fclose (stdout);
	fclose (stderr);
	QuitAllServers();
	Group2ServerClear();
	return(0);
#endif /*!ALONE*/
}

#if DEBUG
/* debugup and debugdown -- lower or raise debugging level respectively*/
static void debugup() { debug_level++; }

static void debugdown() { debug_level--; }
#endif /*DEBUG*/

#if ALONE
/* setup_server_socket -- create/setup socket that clients will contact
	server on.
    parameters
	nothing
    return
	socket we setup
*/
int setup_server_socket()
{
#if !LOCAL_ONLY
	struct sockaddr_in saddr;	/*address struct for server socket*/
	struct servent	*sp;
#else /*LOCAL_ONLY*/
	struct sockaddr_un saddr;	/*address struct for server socket*/
#endif /*LOCAL_ONLY*/
	int s;	/*holds socket fd*/
#if !LOCAL_ONLY
#ifndef DNNTP_PORT
	sp = getservbyname(DNNTP_SERVICE_ID, "tcp");
	if (sp == NULL) {
#if SYSLOG
		syslog(LOG_ERR, "server_socket_setup: tcp/%s, unknown service.",
			DNNTP_SERVICE_ID);
#endif /*SYSLOG*/
		exit(1);
	}
#endif /*DNNTP_PORT*/
#endif /*!LOCAL_ONLY*/
	bzero((char *) &saddr, sizeof(saddr));
#if LOCAL_ONLY
	saddr.sun_family = AF_UNIX;
	(void) strcpy(saddr.sun_path, DNNTP_SOCKET_NAME);
	s = socket(AF_UNIX, SOCK_STREAM, 0);
#else /*!LOCAL_ONLY*/
	saddr.sin_family = AF_INET;
	saddr.sin_addr.s_addr = htonl(INADDR_ANY);
#ifndef DNNTP_PORT
	saddr.sin_port = sp->s_port;
#else /*!DNNTP_PORT*/
	saddr.sin_port = DNNTP_PORT;
#endif /*!DNNTP_PORT*/
	s = socket(AF_INET, SOCK_STREAM, 0);
#endif /*!LOCAL_ONLY*/
	if (s < 0) {
#if SYSLOG
		syslog(LOG_ERR, "server_socket_setup: unable to get socket, \
socket: %m");
#endif /*SYSLOG*/
		exit(1);
	}
#ifdef SO_REUSEADDR
	{
	int on = 1;
	if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *) &on,
		sizeof (on)) < 0)
#if SYSLOG
		syslog(LOG_ERR, "server_socket_setup: unable to setsocketopt(\
SO_REUSEADDR): %m");
#endif /*SYSLOG*/
	}
#endif /*SO_REUSEADDR*/
	if (bind(s, (struct sockaddr *) &saddr, sizeof(saddr)) < 0) {
#if SYSLOG
		syslog(LOG_ERR, "setup_server_socket: bind: %m");
#endif /*SYSLOG*/
		exit(1);
	}
	if (listen(s, SOMAXCONN) < 0) {
#if SYSLOG
		syslog(LOG_ERR, "setup_server_socket: listen: %m");
#endif /*SYSLOG*/
		exit(1);
	}
	return(s);
}
#endif /*ALONE*/

#if ALONE && !defined(USG)
/* baby_killer -- reap children processes (that have exited)
    parameters
	nothing
    return
	nothing
*/
#ifdef ultrix
static void baby_killer()
#else /*!ultrix*/
static int baby_killer()
#endif /*!ultrix*/
{
	union wait status;
	while (wait3(&status, WNOHANG, (struct rusage *)0) >0);
}
#endif /*ALONE && !defined(USG)*/

#if ALONE
/* make_stdio -- make given fd the std[in|out|err]
    parameters
	fd: file descriptor to make stdio

    return
	nothing
*/
void make_stdio(fd)
int fd;
{
		/*normally there is some junk on 0, 1, 2 to start
		(put there by dissasoc)*/
	if(fd != 0){
		(void) dup2(fd, 0);
		(void) close(fd);
	}
	(void) dup2(0, 1);
	(void) dup2(0, 2);
}
#endif /*ALONE*/


#if ALONE
/* disassoc -- make this process a daemon by dumping controling
	terminal, and process group, and open "/" on fds 0-2 so
	that they are claimed (and won't re-do controling terminal
    parameters
	nothing
    return
	nothing
*/
void disassoc()
{
int i;

#ifdef USG
	(void) signal(SIGTERM, SIG_IGN);
	(void) signal(SIGINT, SIG_IGN);
	(void) signal(SIGQUIT, SIG_IGN);
#endif /*USG*/
#if NOT_RUNNING_UNDER_NANNY
	switch (fork()) {
		case -1:
#if SYSLOG
			syslog(LOG_ERR, "disassoc: failed to make 1st child %m.");
#endif /*SYSLOG*/
			exit(1);
		break;
		case 0:
		break;
		default:	/*parent process*/
			exit(0);
		break;
	}
#endif /*NOT_RUNNING_UNDER_NANNY*/
		/*note: NOFILE doesn't acuratily reflect number of fds*/
		/*but we expect to chatch most/enough this way*/
	for (i=0; i < NOFILE; i++)
		(void) close(i);
	i = open(DNNTP_DEV_NULL, O_WRONLY);	/*should be stdout (fd = 0)*/
	i = open(DNNTP_DEV_NULL, O_RDONLY);	/*should be stdin (fd = 1)*/
	i = open(DNNTP_DEV_NULL, O_WRONLY);	/*should be stderr (fd = 2)*/
#ifdef USG
	if (setpgrp() == -1) {
#if SYSLOG
		syslog(LOG_ERR, "disassoc: unable to change progress group");
#endif /*SYSLOG*/
		exit(1);
	}
		/*imunize from process group leader death*/
	(void) signal(SIGHUP, SIG_IGN);
#if NOT_RUNNING_UNDER_NANNY
	switch (fork()) {
		case -1:
#if SYSLOG
			syslog(LOG_ERR, "disassoc: failed to make 2st child %m.");
#endif /*SYSLOG*/
			exit(1);
		break;
		case 0:
		break;
		default:	/*first child process(parent of the one
				created by fork)*/
			exit(0);
		break;
	}
#endif /*NOT_RUNNING_UNDER_NANNY*/
	umask(033);
#else /*!USG*/
	if (setpgrp(0, getpid()) == -1) {
#if SYSLOG
		syslog(LOG_ERR, "disassoc: unable to change progress group");
#endif /*SYSLOG*/
		exit(1);
	}
	if ((i = open("/dev/tty", O_RDWR, 0)) >= 0) {
			/*drop controlling terminal*/
#ifdef TIOCNOTTY
		(void) ioctl(i, TIOCNOTTY, (char *)NULL);
#endif /*TIOCNOTTY*/
		(void) close(i);
	}
#endif /*!USG*/
	i = open("/", O_RDONLY, 0);
	if(i >= 0) {	/*shouldn't happen since we closed all fds*/
		(void) dup2(i, 0);
		(void) close(i);
	}
	(void) dup2(0, 1);
	(void) dup2(0, 2);
}
#endif /*ALONE*/
#if DNNTP_MAYBE_ROOT
/* turn_to_news -- change our uid to be what it ought to be so
we don't have such devistating powers of destruction.  But check if
it is really nessicary.
	return
		0 if no change, 1 if changed, -1 if problems
*/
static int turn_to_news()
{
struct passwd *pw;
	if (getuid() == DNNTP_ROOT_UID) {
		pw = getpwnam(DNNTP_UID_NAME);
		if (!pw)
			return (-1);
		if (setuid(pw->pw_uid) < 0)
			return (-1);
	}
	return (0);
}
#endif /*DNNTP_MAYBE_ROOT*/
